﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Xml;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

namespace ConditionalFormatting
{
    public partial class Form1 : Form
    {
        public System.IO.MemoryStream stream, stream2;
        public System.Xml.XmlTextWriter xw2, xw;
        public XmlReader xr, xr2;
        public Form1()
        {
            InitializeComponent();
            this.gridGroupingControl1.Size = new System.Drawing.Size(650, 250);
            OleDbConnection connection = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\\..\\ACC.MDB");
            OleDbDataAdapter adapter = new OleDbDataAdapter("SELECT * FROM Statistics", connection);
            DataSet dset = new DataSet();
            adapter.Fill(dset);
            this.gridGroupingControl1.DataSource = dset.Tables[0];

            this.gridGroupingControl1.TableModel.EnableLegacyStyle = false;
            this.gridGroupingControl1.GridVisualStyles = GridVisualStyles.Office2010Blue;
            this.gridGroupingControl1.GridOfficeScrollBars = OfficeScrollBars.Metro;

            gridGroupingControl1.TableDescriptor.AllowEdit = false;
            gridGroupingControl1.TableDescriptor.AllowNew = false;
            gridGroupingControl1.TableDescriptor.AllowRemove = false;
            stream = new System.IO.MemoryStream();
        }
        public void conditionalformatting()
        {
            if (gridGroupingControl1.TableDescriptor.ConditionalFormats.Count == 0)
            {
                GridConditionalFormatDescriptor format1 = new GridConditionalFormatDescriptor("specialColor1");
                format1.Expression = "[School] like 'NC State'";
                format1.Appearance.AnyRecordFieldCell.BackColor = Color.LightGray;
                gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format1);

                GridConditionalFormatDescriptor format2 = new GridConditionalFormatDescriptor("specialColor2");
                format2.Expression = "[School] like 'Virginia'";
                format2.Appearance.AnyRecordFieldCell.BackColor = Color.LightGreen;
                gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format2);

                GridConditionalFormatDescriptor format3 = new GridConditionalFormatDescriptor("specialColor3");
                format3.Expression = "[Sport] like \'Base*\'";
                format3.Appearance.AnyRecordFieldCell.Font.Bold = true;
                gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format3);

                GridConditionalFormatDescriptor format4 = new GridConditionalFormatDescriptor("specialColor4");
                format4.Expression = "[Sport] like \'F*\'";
                format4.Appearance.AnyRecordFieldCell.TextColor = Color.DarkBlue;
                gridGroupingControl1.TableDescriptor.ConditionalFormats.Add(format4);

            }
        }
        private void button1_Click(object sender, EventArgs e)
        {
            conditionalformatting();
            FileDialog dlg = new SaveFileDialog();
            dlg.AddExtension = true;
            dlg.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.*";
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                xw = new XmlTextWriter(dlg.FileName, System.Text.Encoding.UTF8);
                xw.Formatting = System.Xml.Formatting.Indented;
                this.gridGroupingControl1.WriteXmlSchema(xw);
                xw.Close();
            }
                        
        }

        private void button2_Click(object sender, EventArgs e)
        {
            FileDialog dlg = new OpenFileDialog();
            dlg.Filter = "xml files (*.xml)|*.xml|All files (*.*)|*.*";
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                xr = new XmlTextReader(dlg.FileName);
                this.gridGroupingControl1.ApplyXmlSchema(xr);
                xr.Close();
            }                  
            
        }

        private void button3_Click(object sender, EventArgs e)
        {
            gridGroupingControl1.TableDescriptor.ConditionalFormats.Clear();

        }
    }
}
